Index: krita/plugins/extensions/scripting/scripts/decorations/VanishingPoints.rb
===================================================================
--- krita/plugins/extensions/scripting/scripts/decorations/VanishingPoints.rb	(revision 1163293)
+++ krita/plugins/extensions/scripting/scripts/decorations/VanishingPoints.rb	(working copy)
@@ -14,7 +14,7 @@
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
-def drawDecoration( gc, documentOffset, area, converter)
+def drawDecoration( gc, updateRect, converter)
     x_c = 800
     y_c = 600
     painter = Qt::Internal.kross2smoke( gc, Qt::Painter )
Index: krita/plugins/extensions/scripting/kis_script_decoration.cc
===================================================================
--- krita/plugins/extensions/scripting/kis_script_decoration.cc	(revision 1163293)
+++ krita/plugins/extensions/scripting/kis_script_decoration.cc	(working copy)
@@ -39,8 +39,14 @@
     delete d;
 }
 
-void KisScriptDecoration::drawDecoration(QPainter& gc, const QPoint & documentOffset, const QRect& area, const KoViewConverter &converter)
+void KisScriptDecoration::drawDecoration(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter)
 {
     dbgScript << "Call to drawDecoration";
-    d->action->callFunction("drawDecoration", QVariantList() << qVariantFromValue((void*)&gc) << documentOffset << area << qVariantFromValue((void*)&converter));
+
+    QVariantList list;
+    list << qVariantFromValue((void*)&gc)
+         << updateRect
+         << qVariantFromValue((void*)converter);
+
+    d->action->callFunction("drawDecoration", list);
 }
Index: krita/plugins/extensions/scripting/kis_script_decoration.h
===================================================================
--- krita/plugins/extensions/scripting/kis_script_decoration.h	(revision 1163293)
+++ krita/plugins/extensions/scripting/kis_script_decoration.h	(working copy)
@@ -37,7 +37,7 @@
     KisScriptDecoration(Kross::Action* _action, KisView2* _view);
     virtual ~KisScriptDecoration();
 protected:
-    virtual void drawDecoration(QPainter& gc, const QPoint & documentOffset, const QRect& area, const KoViewConverter &converter);
+    void drawDecoration(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter);
 private:
     struct Private;
     Private* const d;
Index: krita/plugins/tools/defaulttools/kis_tool_gradient.cc
===================================================================
--- krita/plugins/tools/defaulttools/kis_tool_gradient.cc	(revision 1163293)
+++ krita/plugins/tools/defaulttools/kis_tool_gradient.cc	(working copy)
@@ -119,7 +119,7 @@
 
                 if (canvasWidget) {
                     beginOpenGL();
-                    canvasWidget->setPixelToViewTransformation();
+                    canvasWidget->setupImageToWidgetTransformation();
 
                     glMatrixMode(GL_MODELVIEW);
                     glTranslatef(0.5, 0.5, 0.0);
Index: krita/plugins/tools/defaulttools/kis_tool_pan.cpp
===================================================================
--- krita/plugins/tools/defaulttools/kis_tool_pan.cpp	(revision 0)
+++ krita/plugins/tools/defaulttools/kis_tool_pan.cpp	(revision 0)
@@ -0,0 +1,202 @@
+/*
+ *  Copyright (c) 2010 Dmitry Kazakov <dimula73@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#include "kis_tool_pan.h"
+
+#include <QScrollBar>
+
+#include <KoPointerEvent.h>
+#include <KoCanvasBase.h>
+#include <KoCanvasController.h>
+#include <KoCanvasControllerWidget.h>
+
+#include <kis_canvas2.h>
+
+#include "kis_cursor.h"
+#include "kis_coordinates_converter.h"
+
+
+const qreal KisToolPan::m_checkerRadius = 50;
+
+KisToolPan::KisToolPan(KoCanvasBase * canvas)
+        :  KisTool(canvas, KisCursor::openHandCursor())
+{
+    setObjectName("tool_pan");
+    m_rotationMode = false;
+    m_defaultCursor = KisCursor::openHandCursor();
+}
+
+KisToolPan::~KisToolPan()
+{
+}
+
+bool KisToolPan::wantsAutoScroll() const
+{
+    return false;
+}
+
+void KisToolPan::paint(QPainter& gc, const KoViewConverter &converter)
+{
+    Q_UNUSED(converter);
+    if(m_rotationMode) {
+        const KisCoordinatesConverter *converter = kritaCanvas()->coordinatesConverter();
+        QPointF centerPoint = converter->flakeCenterPoint();
+
+        QBrush fillBrush(QColor(0,0,0,100));
+        QPen checkerPen(QColor(255,255,255,100), 5., Qt::SolidLine, Qt::RoundCap);
+
+        gc.save();
+
+        gc.setPen(Qt::NoPen);
+        gc.setBrush(fillBrush);
+        gc.drawEllipse(centerPoint, m_checkerRadius, m_checkerRadius);
+
+        gc.setPen(checkerPen);
+        gc.drawLine(centerPoint, centerPoint + QPointF(0, -m_checkerRadius));
+
+        gc.restore();
+    }
+}
+
+KisCanvas2* KisToolPan::kritaCanvas() const
+{
+    KisCanvas2 *kritaCanvas = dynamic_cast<KisCanvas2*>(canvas());
+    Q_ASSERT(kritaCanvas);
+    return kritaCanvas;
+}
+
+bool KisToolPan::isInCheckerArea(QPointF pt)
+{
+    QPointF centerPoint = widgetCenterInWidgetPixels();
+    pt -= centerPoint;
+
+    return pt.x() * pt.x() + pt.y() * pt.y() <= m_checkerRadius * m_checkerRadius;
+}
+
+qreal KisToolPan::calculateAngle(QPointF oldPoint,
+                                 QPointF newPoint)
+{
+    QPointF centerPoint = widgetCenterInWidgetPixels();
+    oldPoint -= centerPoint;
+    newPoint -= centerPoint;
+
+    qreal oldAngle = atan2(oldPoint.y(), oldPoint.x());
+    qreal newAngle = atan2(newPoint.y(), newPoint.x());
+
+    return (180 / 3.14) * (newAngle - oldAngle);
+}
+
+void KisToolPan::mousePressEvent(KoPointerEvent *e)
+{
+    m_lastPosition = convertDocumentToWidget(e->point);
+    e->accept();
+
+    m_defaultCursor = KisCursor::closedHandCursor();
+    adjustCursor();
+
+    if(isInCheckerArea(m_lastPosition)) {
+        kritaCanvas()->resetCanvasTransformations();
+    }
+}
+
+void KisToolPan::adjustCursor()
+{
+    QPoint pt = canvas()->canvasWidget()->mapFromGlobal(QCursor::pos());
+
+    if(m_rotationMode && isInCheckerArea(pt)) {
+        useCursor(KisCursor::pointingHandCursor());
+    }
+    else {
+        useCursor(m_defaultCursor);
+    }
+}
+
+void KisToolPan::mouseMoveEvent(KoPointerEvent *e)
+{
+    Q_ASSERT(canvas());
+    Q_ASSERT(canvas()->canvasController());
+
+    QPointF actualPosition = convertDocumentToWidget(e->point);
+
+    adjustCursor();
+
+    if (!e->buttons())
+        return;
+    e->accept();
+
+    if(e->modifiers() & Qt::ShiftModifier) {
+        if(!isInCheckerArea(actualPosition)) {
+            qreal angle = calculateAngle(m_lastPosition, actualPosition);
+            kritaCanvas()->rotateCanvas(angle);
+        }
+    }
+    else {
+        QPointF distance(m_lastPosition - actualPosition);
+        canvas()->canvasController()->pan(distance.toPoint());
+    }
+
+    m_lastPosition = actualPosition;
+}
+
+void KisToolPan::mouseReleaseEvent(KoPointerEvent *e)
+{
+    Q_UNUSED(e);
+    m_defaultCursor = KisCursor::openHandCursor();
+    adjustCursor();
+}
+
+void KisToolPan::keyPressEvent(QKeyEvent *event)
+{
+    KoCanvasControllerWidget *canvasControllerWidget = dynamic_cast<KoCanvasControllerWidget*>(canvas()->canvasController());
+    if (!canvasControllerWidget) {
+        return;
+    }
+    switch (event->key()) {
+        case Qt::Key_Up:
+            canvasControllerWidget->pan(QPoint(0, -canvasControllerWidget->verticalScrollBar()->singleStep()));
+            break;
+        case Qt::Key_Down:
+            canvasControllerWidget->pan(QPoint(0, canvasControllerWidget->verticalScrollBar()->singleStep()));
+            break;
+        case Qt::Key_Left:
+            canvasControllerWidget->pan(QPoint(-canvasControllerWidget->horizontalScrollBar()->singleStep(), 0));
+            break;
+        case Qt::Key_Right:
+            canvasControllerWidget->pan(QPoint(canvasControllerWidget->horizontalScrollBar()->singleStep(), 0));
+            break;
+        case Qt::Key_Shift:
+            m_rotationMode = true;
+            kritaCanvas()->updateCanvas();
+            adjustCursor();
+            break;
+    }
+    event->accept();
+}
+
+void KisToolPan::keyReleaseEvent(QKeyEvent *event)
+{
+    switch (event->key()) {
+        case Qt::Key_Shift:
+            m_rotationMode = false;
+            kritaCanvas()->updateCanvas();
+            adjustCursor();
+            break;
+    }
+}
+
+#include "kis_tool_pan.moc"
Index: krita/plugins/tools/defaulttools/CMakeLists.txt
===================================================================
--- krita/plugins/tools/defaulttools/CMakeLists.txt	(revision 1163293)
+++ krita/plugins/tools/defaulttools/CMakeLists.txt	(working copy)
@@ -10,6 +10,7 @@
     kis_tool_measure.cc
     kis_tool_path.cc
     kis_tool_move.cc
+    kis_tool_pan.cpp
     )
 
 kde4_add_ui_files(kritadefaulttools_PART_SRCS wdgcolorpicker.ui wdgmovetool.ui)
@@ -45,8 +46,6 @@
     tool_freehand_cursor.png
     tool_fill_cursor.png
     tool_gradient_cursor.png
-    openhand_cursor.xpm
-    closedhand_cursor.xpm
     DESTINATION ${DATA_INSTALL_DIR}/krita/pics)
 
 install( FILES  kritadefaulttools.desktop  DESTINATION ${SERVICES_INSTALL_DIR})
Index: krita/plugins/tools/defaulttools/default_tools.cc
===================================================================
--- krita/plugins/tools/defaulttools/default_tools.cc	(revision 1163293)
+++ krita/plugins/tools/defaulttools/default_tools.cc	(working copy)
@@ -39,6 +39,7 @@
 #include "kis_tool_measure.h"
 #include "kis_tool_path.h"
 #include "kis_tool_move.h"
+#include "kis_tool_pan.h"
 
 K_PLUGIN_FACTORY(DefaultToolsFactory, registerPlugin<DefaultTools>();)
 K_EXPORT_PLUGIN(DefaultToolsFactory("krita"))
@@ -59,6 +60,7 @@
     r->add(new KisToolMeasureFactory(r, QStringList()));
     r->add(new KisToolPathFactory(r, QStringList()));
     r->add(new KisToolMoveFactory(r, QStringList()));
+    r->add(new KisToolPanFactory(r, QStringList()));
 }
 
 DefaultTools::~DefaultTools()
Index: krita/plugins/tools/defaulttools/kis_tool_pan.h
===================================================================
--- krita/plugins/tools/defaulttools/kis_tool_pan.h	(revision 0)
+++ krita/plugins/tools/defaulttools/kis_tool_pan.h	(revision 0)
@@ -0,0 +1,91 @@
+/*
+ *  Copyright (c) 2010 Dmitry Kazakov <dimula73@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#ifndef KIS_TOOL_PAN_H_
+#define KIS_TOOL_PAN_H_
+
+#include <KoPanTool.h>
+#include <KoToolFactoryBase.h>
+#include <kis_tool.h>
+
+class KoCanvasBase;
+class KisCanvas2;
+
+class KisToolPan : public KisTool
+{
+
+    Q_OBJECT
+
+public:
+    KisToolPan(KoCanvasBase * canvas);
+    virtual ~KisToolPan();
+
+
+public:
+
+    bool wantsAutoScroll() const;
+    virtual void mousePressEvent(KoPointerEvent *event);
+    virtual void mouseMoveEvent(KoPointerEvent *event);
+    virtual void mouseReleaseEvent(KoPointerEvent *event);
+    void keyPressEvent(QKeyEvent *event);
+    void keyReleaseEvent(QKeyEvent *event);
+
+    virtual void paint(QPainter& gc, const KoViewConverter &converter);
+
+//    virtual QWidget* createOptionWidget();
+//    virtual QWidget* optionWidget();
+
+private:
+    void adjustCursor();
+    bool isInCheckerArea(QPointF pt);
+    qreal calculateAngle(QPointF oldPoint, QPointF newPoint);
+    KisCanvas2* kritaCanvas() const;
+
+private:
+    static const qreal m_checkerRadius;
+
+    QCursor m_defaultCursor;
+    QPointF m_lastPosition;
+    bool m_rotationMode;
+};
+
+
+class KisToolPanFactory : public KoToolFactoryBase
+{
+
+public:
+    KisToolPanFactory(QObject *parent, const QStringList&)
+            : KoToolFactoryBase(parent, KoPanTool_ID) {
+        setToolTip(i18n("Move and rotate your canvas"));
+        setToolType(navigationToolType());
+        setActivationShapeId(KRITA_TOOL_ACTIVATION_ID_ALWAYS_ACTIVE);
+        setPriority(5);
+        setIcon("krita_tool_pan");
+        //setShortcut( QKeySequence( Qt::SHIFT + Qt::Key_V ) );
+    }
+
+    virtual ~KisToolPanFactory() {}
+
+    virtual KoToolBase * createTool(KoCanvasBase *canvas) {
+        return new KisToolPan(canvas);
+    }
+
+};
+
+#endif // KIS_TOOL_PAN_H_
+
Index: krita/plugins/assistants/RulerAssistant/RulerAssistant.cc
===================================================================
--- krita/plugins/assistants/RulerAssistant/RulerAssistant.cc	(revision 1163293)
+++ krita/plugins/assistants/RulerAssistant/RulerAssistant.cc	(working copy)
@@ -22,8 +22,9 @@
 
 #include <QPainter>
 #include <QLinearGradient>
+#include <QTransform>
 
-#include <KoViewConverter.h>
+#include "kis_coordinates_converter.h"
 
 #include <math.h>
 
@@ -67,29 +68,39 @@
     return sqrt(p.x() * p.x() + p.y() * p.y());
 }
 
-void RulerAssistant::drawAssistant(QPainter& _painter, const QPoint& documentOffset,  const QRect& _area, const KoViewConverter &_converter) const
+void RulerAssistant::drawAssistant(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter)
 {
-    Q_UNUSED(documentOffset);
-    Q_UNUSED(_area);
+    Q_UNUSED(updateRect);
     Q_ASSERT(handles().size() == 2);
+
+    QTransform initialTransform = converter->documentToWidgetTransform();
+
     // Draw the gradient
     QPointF p1 = *handles()[0];
     QPointF p2 = *handles()[1];
-    _painter.save();
+    gc.save();
     {
-        _painter.translate(_converter.documentToView(p1));
-        _painter.rotate(angle(p1, p2) / M_PI * 180);
+        QTransform gradientTransform = initialTransform;
+
+        gradientTransform.translate(p1.x(), p1.y());
+        gradientTransform.rotate(angle(p1, p2) / M_PI * 180);
+        gc.setTransform(gradientTransform);
+
         QLinearGradient gradient(0, -30, 0, 30);
         gradient.setColorAt(0, QColor(0, 0, 0, 0));
         gradient.setColorAt(0.5, QColor(0, 0, 0, 100));
         gradient.setColorAt(1, QColor(0, 0, 0, 0));
-        _painter.setBrush(gradient);
-        _painter.setPen(QPen(Qt::NoPen));
-        _painter.drawRect(_converter.documentToView(QRectF(0, -50, norm2(p2 - p1), 100)));
+        gc.setBrush(gradient);
+        gc.setPen(QPen(Qt::NoPen));
+        gc.drawRect(QRectF(0, -50, norm2(p2 - p1), 100));
     }
-    _painter.restore();
-    _painter.drawLine(_converter.documentToView(p1),
-                      _converter.documentToView(p2));
+    gc.restore();
+
+    gc.save();
+    gc.setTransform(initialTransform);
+    gc.setPen(QColor(0, 0, 0, 125));
+    gc.drawLine(p1,p2);
+    gc.restore();
 }
 
 RulerAssistantFactory::RulerAssistantFactory()
Index: krita/plugins/assistants/RulerAssistant/RulerAssistant.h
===================================================================
--- krita/plugins/assistants/RulerAssistant/RulerAssistant.h	(revision 1163293)
+++ krita/plugins/assistants/RulerAssistant/RulerAssistant.h	(working copy)
@@ -27,7 +27,7 @@
 public:
     RulerAssistant();
     virtual QPointF adjustPosition(const QPointF& point) const;
-    virtual void drawAssistant(QPainter& gc, const QPoint& documentOffset,  const QRect& area, const KoViewConverter &converter) const;
+    void drawAssistant(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter);
 private:
     QPointF project(const QPointF& pt) const;
 };
Index: krita/plugins/assistants/RulerAssistant/kis_ruler_assistant_tool.cc
===================================================================
--- krita/plugins/assistants/RulerAssistant/kis_ruler_assistant_tool.cc	(revision 1163293)
+++ krita/plugins/assistants/RulerAssistant/kis_ruler_assistant_tool.cc	(working copy)
@@ -109,11 +109,15 @@
 
 void KisRulerAssistantTool::paint(QPainter& _gc, const KoViewConverter &_converter)
 {
+    QColor handlesColor(0, 0, 0, 125);
+
     foreach(const KisPaintingAssistantHandleSP handle, m_handles) {
         if (handle == m_handleDrag) {
-            _gc.setBrush(QColor(0, 0, 0, 125));
+            _gc.setPen(handlesColor);
+            _gc.setBrush(handlesColor);
         } else {
-            _gc.setBrush(QColor(0, 0, 0, 0));
+            _gc.setPen(handlesColor);
+            _gc.setBrush(Qt::transparent);
         }
         _gc.drawEllipse(QRectF(_converter.documentToView(*handle) -  QPointF(5, 5), QSizeF(10, 10)));
     }
Index: krita/ui/kis_view2.cpp
===================================================================
--- krita/ui/kis_view2.cpp	(revision 1163293)
+++ krita/ui/kis_view2.cpp	(working copy)
@@ -79,6 +79,7 @@
 #include "kis_config_notifier.h"
 #include "kis_statusbar.h"
 #include "canvas/kis_canvas2.h"
+#include "kis_coordinates_converter.h"
 #include "kis_doc2.h"
 #include "kis_factory2.h"
 #include "kis_filter_manager.h"
@@ -210,11 +211,14 @@
     m_d->viewConverter = new KoZoomHandler();
 
     KoCanvasControllerWidget *canvasController = new KoCanvasControllerWidget(this);
+    canvasController->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
+    canvasController->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
+    canvasController->setDrawShadow(false);
+    canvasController->setCanvasMode(KoCanvasController::Infinite);
+
     m_d->canvasController = canvasController;
-    m_d->canvasController->setDrawShadow(false);
-    m_d->canvasController->setMargin(10);
-    m_d->canvasController->setCanvasMode(KoCanvasController::Infinite);
 
+
     m_d->canvas = new KisCanvas2(m_d->viewConverter, this, doc->shapeController());
     m_d->canvasController->setCanvas(m_d->canvas);
 
@@ -238,6 +242,21 @@
     m_d->mirrorCanvas->setShortcut(QKeySequence(Qt::CTRL + Qt::Key_I));
     connect(m_d->mirrorCanvas, SIGNAL(toggled(bool)),m_d->canvas, SLOT(mirrorCanvas(bool)));
 
+    KAction *rotateCanvasRight = new KAction(i18n("Rotate Canvas Right"), this);
+    actionCollection()->addAction("rotate_canvas_right", rotateCanvasRight);
+    rotateCanvasRight->setShortcut(QKeySequence("Ctrl+]"));
+    connect(rotateCanvasRight, SIGNAL(triggered()),m_d->canvas, SLOT(rotateCanvasRight15()));
+
+    KAction *rotateCanvasLeft = new KAction(i18n("Rotate Canvas Left"), this);
+    actionCollection()->addAction("rotate_canvas_left", rotateCanvasLeft);
+    rotateCanvasLeft->setShortcut(QKeySequence("Ctrl+["));
+    connect(rotateCanvasLeft, SIGNAL(triggered()),m_d->canvas, SLOT(rotateCanvasLeft15()));
+
+    KAction *resetCanvasTransformations = new KAction(i18n("Reset Canvas Transformations"), this);
+    actionCollection()->addAction("reset_canvas_transformations", resetCanvasTransformations);
+    resetCanvasTransformations->setShortcut(QKeySequence("Ctrl+'"));
+    connect(resetCanvasTransformations, SIGNAL(triggered()),m_d->canvas, SLOT(resetCanvasTransformations()));
+
     if (shell())
     {
         KoToolBoxFactory toolBoxFactory(m_d->canvasController, i18n("Tools"));
@@ -278,6 +297,7 @@
 
     // canvas sends signal that origin is changed
     connect(m_d->canvas, SIGNAL(documentOriginChanged()), m_d->zoomManager, SLOT(pageOffsetChanged()));
+    connect(m_d->canvas, SIGNAL(scrollAreaSizeChanged()), m_d->zoomManager, SLOT(slotScrollAreaSizeChanged()));
 
     setAcceptDrops(true);
 }
@@ -680,15 +700,13 @@
     m_d->zoomManager->zoomController()->setPageSize(size);
     m_d->zoomManager->zoomController()->setDocumentSize(size);
 
-    QSize documentSize(int(ceil(m_d->viewConverter->documentToViewX(image()->width()  / image()->xRes()))),
-                       int(ceil(m_d->viewConverter->documentToViewY(image()->height() / image()->yRes()))));
-    m_d->canvasController->updateDocumentSize(documentSize, true);
+    canvasBase()->notifyZoomChanged();
+    QSize widgetSize = canvasBase()->coordinatesConverter()->imageRectInWidgetPixels().toAlignedRect().size();
+    m_d->canvasController->updateDocumentSize(widgetSize, true);
 
     m_d->zoomManager->updateGUI();
 
     //update view
-    canvasBase()->preScale();
-    canvasBase()->adjustOrigin();
     canvas()->update();
 }
 
Index: krita/ui/kis_selection_decoration.cc
===================================================================
--- krita/ui/kis_selection_decoration.cc	(revision 1163293)
+++ krita/ui/kis_selection_decoration.cc	(working copy)
@@ -23,8 +23,6 @@
 #include <kdebug.h>
 #include <klocale.h>
 
-#include <KoViewConverter.h>
-
 #include "kis_types.h"
 #include "kis_view2.h"
 #include "kis_selection.h"
@@ -34,6 +32,7 @@
 #include "kis_selection_manager.h"
 #include "canvas/kis_canvas2.h"
 #include "kis_canvas_resource_provider.h"
+#include "kis_coordinates_converter.h"
 
 KisSelectionDecoration::KisSelectionDecoration(KisView2* view)
     : KisCanvasDecoration("selection", i18n("Selection decoration"), view), m_mode(Ants)
@@ -169,77 +168,71 @@
     }
 }
 
-void KisSelectionDecoration::drawDecoration(QPainter& painter, const QPoint& documentOffset, const QRect& area, const KoViewConverter& converter)
+void KisSelectionDecoration::drawDecoration(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter)
 {
+    Q_UNUSED(updateRect);
 
-    Q_UNUSED(documentOffset)
-    Q_UNUSED(area);
     KisSelectionSP selection = view()->selection();
     if (!selection || selection->isDeselected() || !selection->isVisible())
         return;
 
-    qreal sx, sy;
-    converter.zoom(&sx, &sy);
-
     if (m_mode == Mask) {
         Q_ASSERT_X(0, "KisSelectionDecoration.cc", "MASK MODE NOT SUPPORTED YET!");
     }
-    if (m_mode == Ants && selection && selection->hasPixelSelection()) {
 
-        QTransform matrix;
-        matrix.scale(sx / view()->image()->xRes(), sy / view()->image()->yRes());
+    if (m_mode == Ants && selection->hasPixelSelection()) {
 
-        QTransform oldWorldMatrix = painter.worldTransform();
-        painter.setWorldTransform(matrix, true);
+        QTransform transform = converter->imageToWidgetTransform();
 
-        QTime t;
-        t.start();
-        painter.setRenderHints(0);
+        qreal scaleX, scaleY;
+        converter->imageScale(&scaleX, &scaleY);
 
+        gc.save();
+        gc.setTransform(transform);
+        gc.setRenderHints(0);
+
         QPen pen(m_brushes[m_offset], 0);
 
         int i = 0;
-        painter.setPen(pen);
-        if (1 / view()->image()->xRes()*sx < 3)
+        gc.setPen(pen);
+        if (0.5 * (scaleX + scaleY) < 3) {
             foreach(const QPolygon & polygon, m_simpleOutline) {
-            painter.drawPolygon(polygon);
-            i++;
+                gc.drawPolygon(polygon);
+                i++;
+            }
         } else {
             foreach(const QPolygon & polygon, m_outline) {
-                painter.drawPolygon(polygon);
+                gc.drawPolygon(polygon);
                 i++;
             }
         }
 
-        dbgRender << "Polygons :" << i;
-        dbgRender << "Painting marching ants :" << t.elapsed();
-
-        painter.setWorldTransform(oldWorldMatrix);
+        gc.restore();
     }
-    if (m_mode == Ants && selection && selection->hasShapeSelection()) {
+
+    if (m_mode == Ants && selection->hasShapeSelection()) {
         KisShapeSelection* shapeSelection = static_cast<KisShapeSelection*>(selection->shapeSelection());
 
         QVector<qreal> dashes;
-        qreal space = 4;
-        dashes << 4 << space;
+        dashes << 4 << 4;
 
+        QPen backgroundPen(Qt::white);
+        backgroundPen.setCosmetic(true);
+
         QPainterPathStroker stroker;
         stroker.setWidth(0);
         stroker.setDashPattern(dashes);
         stroker.setDashOffset(m_offset - 4);
+        QPainterPath stroke = stroker.createStroke(shapeSelection->selectionOutline());
 
-        painter.setRenderHint(QPainter::Antialiasing);
-        QColor outlineColor = Qt::black;
+        QTransform transform = converter->documentToWidgetTransform();
 
-        QTransform zoomMatrix;
-        zoomMatrix.scale(sx, sy);
-
-        QPen backgroundPen(Qt::white);
-        backgroundPen.setCosmetic(true);
-        painter.strokePath(zoomMatrix.map(shapeSelection->selectionOutline()), backgroundPen);
-
-        QPainterPath stroke = stroker.createStroke(zoomMatrix.map(shapeSelection->selectionOutline()));
-        painter.fillPath(stroke, outlineColor);
+        gc.save();
+        gc.setTransform(transform);
+        gc.setRenderHint(QPainter::Antialiasing);
+        gc.strokePath(shapeSelection->selectionOutline(), backgroundPen);
+        gc.fillPath(stroke, Qt::black);
+        gc.restore();
     }
 }
 
Index: krita/ui/kis_cursor.cc
===================================================================
--- krita/ui/kis_cursor.cc	(revision 1163293)
+++ krita/ui/kis_cursor.cc	(working copy)
@@ -330,12 +330,12 @@
 
 QCursor KisCursor::openHandCursor()
 {
-    return load("openhand_cursor.xpm");
+    return Qt::OpenHandCursor;
 }
 
 QCursor KisCursor::closedHandCursor()
 {
-    return load("closedhand_cursor.xpm");
+    return Qt::ClosedHandCursor;
 }
 
 QCursor KisCursor::rotateCursor()
Index: krita/ui/kis_zoom_manager.h
===================================================================
--- krita/ui/kis_zoom_manager.h	(revision 1163293)
+++ krita/ui/kis_zoom_manager.h	(working copy)
@@ -60,6 +60,7 @@
 private slots:
 
     void slotZoomChanged(KoZoomMode::Mode mode, qreal zoom);
+    void slotScrollAreaSizeChanged();
     void toggleShowRulers(bool show);
     void mousePositionChanged(const QPoint &pos);
     void changeAspectMode(bool aspectMode);
Index: krita/ui/kis_painting_assistants_manager.h
===================================================================
--- krita/ui/kis_painting_assistants_manager.h	(revision 1163293)
+++ krita/ui/kis_painting_assistants_manager.h	(working copy)
@@ -42,7 +42,8 @@
     void setup(KActionCollection * collection);
     QList<KisPaintingAssistantHandleSP> handles();
 protected:
-    virtual void drawDecoration(QPainter& gc, const QPoint& documentOffset,  const QRect& area, const KoViewConverter &converter);
+    void drawDecoration(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter);
+
 private:
     struct Private;
     Private* const d;
